package openmind;
import java.util.*;
import java.io.*;
//import montytagger.JMontyTagger;

//eliminates certain junk words and duplicate words 
public class FileIO {
	//    public static JMontyTagger jTagger = new JMontyTagger();
	private ArrayList alFilePairs;
	
	public String readFile(String sFilename){
		String sOutput = "";
		try{
		    BufferedReader in  = new BufferedReader(new FileReader(sFilename));
		    sOutput = "";
		    String temp_data;
			while ((temp_data = in.readLine()) != null) {
				sOutput += temp_data + "\n";
		    }
		}
		catch(Exception e){
			System.out.println("Could not find "+sFilename);
		}
		return sOutput;
    }
    
   	public StreamTokenizer readStreamFile(String sFilename){
		//String sOutput = "";
		StreamTokenizer stOutput;
		try{
		    BufferedReader in  = new BufferedReader(new FileReader(sFilename));
		    stOutput = new StreamTokenizer(in);
		    stOutput.eolIsSignificant(false);
		    stOutput.wordChars(32,127);
			return stOutput;
    
		}
		catch(Exception e){
			System.out.println("Could not find "+sFilename);
		}
		return null;
	}
	
	public Vector readFileToVector(String sFilename){
		Vector vOutput = new Vector();
		try{
		    BufferedReader in  = new BufferedReader(new FileReader(sFilename));
		    String temp_data;
			while ((temp_data = in.readLine()) != null) {
				vOutput.add(temp_data);
		    }
		}
		catch(Exception e){
			System.out.println("Could not find "+sFilename);
		}
		return vOutput;
    }
	
	public String filterAndCount(String input){
    	String sOutput = "", sKey;
    	Hashtable ht = new Hashtable();
    	StringTokenizer st = new StringTokenizer(input);
    	while (st.hasMoreTokens()){
    		String next = st.nextToken();
    		if(next.equals("is")
		   || next.equals("an")
		   || next.equals("the") 
		   || next.equals("null") 
		   || next.equals("Situation") 
		   || next.equals("was") 
		   || next.equals("this") 
		   || next.equals("that") 
		   || next.equals("a") 
		   || next.equals("at") 
		   || next.equals("while") 
		   || next.equals("who") 
		   || next.equals("what") 
		   || next.equals("where") 
		   || next.equals("why") 
		   || next.equals("how") 
		   || next.equals("you") 
		   || next.equals("me")
		   || next.equals("he") 
		   || next.equals("she") 
		   || next.equals("I") 
		   || next.equals("i") 
		   || next.equals("in") 
		   || next.equals("go") 
		   || next.equals("to") 
		   || next.equals("than") 
		   || next.equals("then") 
		   || next.equals("can") 
		   || next.equals("in,") 
		   || next.equals("have") 
		   || next.equals("has") 
		   || next.equals("them") 
		   || next.equals("his") 
		   || next.equals("hers") 
		   || next.equals("her") 
		   || next.equals("not") 
		   || next.equals("and")
		   || next.equals("picture")
		   || next.equals("description")
		   || next.equals("are")
		   || next.equals("Situation:")
		   	){}//do nothing
		   	else{
			   	if(ht.containsKey(next)){
					Integer iInt = (Integer) ht.get(next);
					int i = iInt.intValue();
					i++;
					iInt = new Integer(i);
					ht.remove(next);
					ht.put(next, iInt);
				}
			    else {
					ht.put(next, new Integer(1));
			    }
		   	}
    	}
		for(Enumeration e = ht.keys(); e.hasMoreElements();){
				sKey = (String) e.nextElement();
				sOutput += sKey + "\t" + String.valueOf(ht.get(sKey)) + "\n";
		}
    	return sOutput;
	}
	static public Vector sort(Hashtable ht, int iNumber){
		//StringTokenizer st = new StringTokenizer(input, "\n");
		Vector v = new Vector();
		Vector vReturn = new Vector();
		Pair[] pairs = new Pair[0];
		//while (st.hasMoreTokens()){
		for(Enumeration e = ht.keys(); e.hasMoreElements();){
			String sKey = (String) e.nextElement();
			String sValue = String.valueOf(ht.get(sKey));
			Pair pair = new Pair(sKey, (new Integer(sValue)).intValue());
			v.add(pair);
		}
		try{
			System.out.println(String.valueOf(v.size()));
			pairs = new Pair[v.size()];
			for(int i=0;i<v.size();i++){
				Pair p = (Pair) v.get(i);
				pairs[i] = p;
			}
			Arrays.sort(pairs);
		}
		catch (Exception e){
			System.out.println("Error with sorting pairs, error: "+e);
		}
		for(int i=0;i<iNumber && i<pairs.length;i++){
			vReturn.add(pairs[i].getWord());
		}
		return vReturn;
	}
	
	
	public String sort(String input){
		StringTokenizer st = new StringTokenizer(input, "\n");
		Vector v = new Vector();
		Pair[] pairs = new Pair[0];
		while (st.hasMoreTokens()){
			try{
				String next = st.nextToken();
				String[] string = next.split("\t");
				Pair pair = new Pair(string[0], (new Integer(string[1])).intValue());
				v.add(pair);
			}
			catch (Exception e){
				System.out.println("Error sorting: next, error: "+e);
			}
		}
		try{
			pairs = new Pair[v.size()];
			for(int i=0;i<v.size();i++){
				Pair p = (Pair) v.get(i);
				pairs[i] = p;
			}
			Arrays.sort(pairs);
		}
		catch (Exception e){
			System.out.println("Error with sorting pairs, error: "+e);
		}
		String output = "";
		for(int i=0;i<v.size();i++){
			output += pairs[i].getWord()+"\t";
			output += pairs[i].getValue() + "\n";
		}
		return output;
	}
}
